/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Parser.hpp"

namespace lispel
{
namespace depel
{

/* ************************************************************************** */
/* ********************************* Parser ********************************* */
/* ************************************************************************** */

Parser::~Parser()
{
  // Clears the value if any
  setValue();
  assert(!value);
}

Cell* Parser::parseDeclaration()
{
  // Simply call through to bison
  if(bison.parse())
    throw std::runtime_error("Error parsing!");

  // No value despite success means EOF
  if(!value)
    throw EndOfInput();

  // Return the value, releasing it; this block should never throw
  assert(value);
  Cell* val(value);
  value=NULL; // Do not free it, reset directly
  return val;
}

} // namespace depel
} // namespace lispel
