/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Action.hpp"
#include "Runtime.hpp"

namespace lispel
{
namespace ellisp
{

/* ************************************************************************** */
/* ********************************* Action ********************************* */
/* ************************************************************************** */

Action::~Action()
{
  // Nothing to do in super-class
}

/* ************************************************************************** */
/* **************************** SignatedAction ****************************** */
/* ************************************************************************** */

bool SignatedAction::accepts(const Arguments& vals) const
{
  return arguments.matches(vals);
}

void SignatedAction::perform(Arguments& vals) const
{
  assert(accepts(vals));
  Arguments castVals;
  arguments.upcast(vals, castVals);

  return performCasted(castVals);
}

/* ************************************************************************** */
/* **************************** CallbackAction ****************************** */
/* ************************************************************************** */

void CallbackAction::performCasted(Arguments& args) const
{
  assert(native);
  native(rt, args);
}

} // namespace ellisp
} // namespace lispel
