/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "AnyType.hpp"
#include "Runtime.hpp"
#include "Atom.hpp"

#include <cassert>

namespace lispel
{
namespace ellisp
{

#define NAME_ANYTYPE Atom("Irgendwas")

/* ************************************************************************** */
/* ****************************** AnyType *********************************** */
/* ************************************************************************** */

AnyType::AnyType(const Runtime& r)
  : Type(NAME_ANYTYPE, r)
{}

void AnyType::define(Runtime& r)
{
  assert(const_cast<const Runtime*>(&r)==&rt);
  r.addType(NAME_ANYTYPE, this);
}

#ifndef NDEBUG
void AnyType::destroyData(void* val) const
{
  assert(false);
}
Elob AnyType::castValueTo(const Elob& val, Ref t) const
{
  assert(false);
}
std::ostream& AnyType::print(std::ostream& out, const void* val) const
{
  assert(false);
}
#endif /* NDEBUG */

Type::Ref AnyType::getAnyType(const Runtime& rt)
{
  return rt.queryType(NAME_ANYTYPE);
}

} // namespace ellisp
} // namespace lispel
