/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Function.hpp"

namespace lispel
{
namespace ellisp
{

/* ************************************************************************** */
/* ****************************** Function ********************************** */
/* ************************************************************************** */

Function::~Function()
{
  // Nothing to be done in super-class
}

/* ************************************************************************** */
/* **************************** SignatedFunction **************************** */
/* ************************************************************************** */

bool SignatedFunction::accepts(const Arguments& vals) const
{
  return arguments.matches(vals);
}

Elob SignatedFunction::eval(const Arguments& vals) const
{
  assert(accepts(vals));
  Arguments castVals;
  arguments.upcast(vals, castVals);

  return evalCasted(castVals);
}

/* ************************************************************************** */
/* **************************** CallbackFunction **************************** */
/* ************************************************************************** */

Elob CallbackFunction::evalCasted(const Arguments& args) const
{
  assert(native);
  return native(rt, args);
}

} // namespace ellisp
} // namespace lispel
