/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "ClassicEval.hpp"
#include "Test.hpp"

#include "CellTypes.hpp"

#include "Elob.hpp"
#include "Cell.hpp"
#include "List.hpp"

#include <memory>
#include <sstream>

namespace lispel
{
using namespace ellib;
namespace tests
{

/* ************************************************************************** */
/* **************************** ClassicEval ********************************* */
/* ************************************************************************** */

ClassicEval::ClassicEval()
  : Runtime()
{
  CellTypes::define(*this);
}

Elob ClassicEval::evalClassic(const std::string& str, Type::Ref t) const
{
  std::istringstream in(str);
  Cell c;
  in >> c;
  Elob val(evaluate(c));

  check(val.getType()==t, "Expected type %s, got type %s",
    t->getName().str().c_str(), val.getType()->getName().str().c_str());

  return val;
}

void ClassicEval::procClassic(const std::string& str)
{
  std::istringstream in(str);
  std::auto_ptr<List> lst(List::input(in));
  processAll(lst.get());
}

} // namespace tests
} // namespace lispel
