/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "DeComparator.hpp"
#include "Test.hpp"

#include "Cell.hpp"

#include <memory>
#include <sstream>

namespace lispel
{
using namespace ellisp;
namespace tests
{

/* ************************************************************************** */
/* **************************** DeComparator ******************************** */
/* ************************************************************************** */

void DeComparator::check(const std::string& de, const std::string& lisp)
{
  if(verbose)
    std::cout << "Parsing '" << de << "'..." << std::endl;

  std::istringstream deIn(de);
  p.setInput(deIn);
  std::auto_ptr<Cell> deExpr(p.parseDeclaration());

  std::ostringstream deOut;
  deOut << *deExpr;

  std::istringstream lispIn(lisp);
  Cell lispExpr(lispIn);

  tests::check(*deExpr==lispExpr,
    "De mismatch:\n'%s'\nshould parse to\n'%s'\nnot\n'%s'",
    de.c_str(), lisp.c_str(), deOut.str().c_str());
}

} // namespace tests
} // namespace lispel
