/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Simple test case for casting.
 */

#include "Test.hpp"
#include "ClassicEval.hpp"

#include "Arithmetic.hpp"

#include "Cell.hpp"

#include <cstdlib>

using namespace lispel;
using namespace ellisp;
using namespace ellib;
using namespace tests;

using namespace std;

int main()
{
  ClassicEval proc;
  Arithmetic::define(proc);

  /* The cast ensures the product is calculated as number, so the real check
   * for casts lies in the type-check of ClassicEval.
   */
  Elob val(proc.evalClassic("(Produkt 2 (_cast Zahl (Summe 5 3)))",
    proc.getNumberType()));
  // This should be calculated exact, only integers involved; so equal is ok
  check(val.getNumber()==2*static_cast<Cell::numberType>(5+3),
    "Casted wrong!");

  // There was a bug with process-evaluating a cast-value
  proc.procClassic("(_cast Zahl 8)");
  
  return EXIT_SUCCESS;
}
