/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Tests dynamic definition of constants.
 */

#include "Test.hpp"
#include "ClassicEval.hpp"

#include "Arithmetic.hpp"

#include <cstdlib>

using namespace lispel;
using namespace ellisp;
using namespace ellib;
using namespace tests;

using namespace std;

int main()
{
  ClassicEval proc;
  Arithmetic::define(proc);

  // Define some constants
  proc.procClassic("(_constant Hundert (Summe 50 50))");
  proc.procClassic("(_constant Greeting \"Hello, world\")");

  // Check them
  Elob val;
  val=proc.evalClassic("Hundert", proc.getIntegerType());
  check(val.getInteger()==100, "Constant Hundert wrong: %d", val.getInteger());
  val=proc.evalClassic("Greeting", proc.getStringType());
  check(val.getString()=="Hello, world", "Constant Greeting wrong: %s",
    val.getString().c_str());

  return EXIT_SUCCESS;
}
