/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Tests the German language frontend with respect to class definitions in all
 * flavours.
 */

#include "DeComparator.hpp"

#include <cstdlib>

using namespace lispel;
using namespace tests;

using namespace std;

int main()
{
  DeComparator proc;

  /* Only members */
  proc.check("Ein Auto hat die Ganzzahl Raeder.",
    "(_class Auto () ((Ganzzahl Raeder)))");
  proc.check("Ein Auto hat die Ganzzahl Raeder und den String Marke.",
    "(_class Auto () ((Ganzzahl Raeder) (String Marke)))");
  proc.check("Ein Tripel hat die Zahl a, die Zahl b und die Zahl c.",
    "(_class Tripel () ((Zahl a) (Zahl b) (Zahl c)))");

  /* Only super types */
  proc.check("Ein Auto ist ein Fahrzeug.",
    "(_class Auto ((Fahrzeug)) ())");
  proc.check("Eine Person ist eine Ganzzahl (das Alter).",
    "(_class Person ((Ganzzahl Alter)) ())");
  proc.check("Ein Mensch ist ein String (der Name) und eine Zahl.",
    "(_class Mensch ((String Name) (Zahl)) ())");
  proc.check("Ein Mensch ist ein String (der Name), eine Zahl und ein String.",
    "(_class Mensch ((String Name) (Zahl) (String)) ())");

  /* Both of those */
  proc.check("Eine CZahl ist eine Zahl (der Realteil); "
    " und hat die Zahl Imaginaerteil.",
    "(_class CZahl ((Zahl Realteil)) ((Zahl Imaginaerteil)))");

  return EXIT_SUCCESS;
}
