/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Tests the German language frontend with respect to function definitions.
 */

#include "Test.hpp"
#include "DeComparator.hpp"

#include <cstdlib>

using namespace lispel;
using namespace tests;

using namespace std;

int main()
{
  DeComparator proc;

  proc.check("Der Sinus von der Zahl a ist 0 .",
    "(_function Sinus ((Zahl a)) 0)");
  proc.check("Die Summe von dem String x und der Zahl y ist"
    " das Produkt von x und y.",
    "(_function Summe ((String x) (Zahl y)) (Produkt x y))");
  proc.check("Das Haus von der Zahl a, der Zahl b und der Zahl c ist 42 .",
    "(_function Haus ((Zahl a) (Zahl b) (Zahl c)) 42)");

  return EXIT_SUCCESS;
}
