/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Tests the German language frontend for conditional values.
 */

#include "DeComparator.hpp"

#include <cstdlib>

using namespace lispel;
using namespace tests;

using namespace std;

int main()
{
  DeComparator proc;

  proc.check("fuer a 5, sonst 3?", "(_if a 5 3)");
  proc.check("die Summe von x, fuer b 3, sonst 2 und 10?",
    "(Summe x (_if b 3 2) 10)");
  proc.check("fuer b die Summe von fuer c 3, sonst 2 und 3, sonst x?",
    "(_if b (Summe (_if c 3 2) 3) x)");

  return EXIT_SUCCESS;
}
