/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Tests the German language frontend for operators.
 */

#include "DeComparator.hpp"

#include <cstdlib>

using namespace lispel;
using namespace tests;

using namespace std;

int main()
{
  DeComparator proc;

  /* Define some operators */
  proc.check("nicht Bedingung a ist die Negation a.",
    "(_function _operator_nicht ((Bedingung a)) (Negation a))");
  proc.check("Zahl a plus Zahl b ist die Summe von a und b.",
    "(_function _operator_plus ((Zahl a) (Zahl b)) (Summe a b))");

  /* Test those */
  proc.check("nicht die Gleichheit von a und b?",
    "(_operator_nicht (Gleichheit a b))");
  proc.check("a plus b?", "(_operator_plus a b)");
  proc.check("die Summe von a und b plus 3?",
    "(Summe a (_operator_plus b 3))");
  proc.check("a plus b plus c?", "(_operator_plus a (_operator_plus b c))");

  return EXIT_SUCCESS;
}
