/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* This is the test for the Strings-module of the runtime-library providing
 * basic string manipulation.
 */

#include "Test.hpp"
#include "ClassicEval.hpp"

#include "Strings.hpp"

#include "List.hpp"
#include "Elob.hpp"

#include <cstdlib>

using namespace lispel;
using namespace ellisp;
using namespace ellib;
using namespace tests;

using namespace std;

int main()
{
  ClassicEval proc;
  Strings::define(proc);

  Elob val;
  #define DO_CHECK(instr, restype, res) \
    val=proc.evalClassic(instr, proc.get##restype##Type()); \
    check(val.get##restype()==res, "Result value mismatch");
  
  DO_CHECK("(Verkettung \"a\" \"bc\" \"d\")", String, "abcd")
  DO_CHECK("(Verkettung \"Trish\")", String, "Trish")
  DO_CHECK("(Verkettung 65 66 67)", String, "ABC")
  DO_CHECK("(Verkettung 97)", String, "a")
  DO_CHECK("(Laenge \"\")", Integer, 0)
  DO_CHECK("(Laenge \"xxx\")", Integer, 3)
  DO_CHECK("(Substring \"abcdef\" 1 3)", String, "bcd")
  DO_CHECK("(Indexzeichen \"abcde\" 2)", Integer, 'c')

  return EXIT_SUCCESS;
}
